import React, { useRef, useEffect, useMemo } from 'react'

export default (props) => {
  const editorRef = useRef()
  const initedRef = useRef(false)
  const id = useMemo(() => `mce-${Math.random().toString(36).substring(2, 10)}`, [])

  useEffect(() => {
    window.tinymce.init({
      selector: `#${id}`,
      menubar: false,
      setup: (editor) => {
        editorRef.current = editor;
        if (props.value) {
          initedRef.current = true
          editor.setContent(props.value)
        }

        editor.on('input', () => {
          props.onChange(editor.getContent());
        })
      }
    });
  // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [id])

  useEffect(() => {
    if (editorRef.current && !initedRef.current) {
      if (props.initd) {
        initedRef.current = true
        editorRef.current.setContent(props.value)
      }
    }
  }, [props.value, props.initd])

  return (
    <textarea id={id} />
  )
}
